; Assembly Source File
; Created 7/25/01, 8:17:28 PM

;***********************************************************************************
;*** KerNO for the TI-89 and TI-92+ By Gregory Dietsche Copyright (C) 2001.      ***
;*** Description: Rough approximation: DoorsOS for NOSTUB Programs...            ***
;***********************************************************************************

;TODO:
;Goal: To provide some features that Kernels provide without the kernel...
;Goal: Dump regs on error to the screen for debugging
;Goal: Dump some/all of the stack to screen for debugging.
;Goal: do what Home Screen Restore Does; possibly hook trap $B to accomplish...

;************************************
;**i may not implement any of this here... it would make kerno into something i don't want it to be...
;**This Would require the program in question to have a simple patch applied
;it would call the exec function at $34 before doing anything else
;KerNO would need to support return value either partially or completely.
;Goal: To lanuch patched ppg programs.
;************************************

;Completed
 ;Goal: To provide a line 1111 emulator similar to the one found on ams 2.04=>
 ;Goal: To provied protection from exceptions
 ;Goal: To break asm size limit
 ;Goal: TO allow asm programs to return a value in an expression hostile AMS versions ($A emulator)
 ;Goal: Provide ESC->ON to break out of programs.


 include "OS.h"

;this macro requires that a4 be initialized with move.l $c8,a4
;prior to its use
ROM_CALL3 macro
 move.l \1*4(a4),a0
 jsr (a0)
 endm
 
;this macro makes use of the line 1111 emulator for making rom calls... 
ROM_CALLF macro
 dc.w $F800+\1
 endm

;makes use of the line 1010 emulator... error codes are those listed in the calc's guide book...
ERR_THROW macro
 dc.w $A000+\1
 endm
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;conditional compilation equates
VTI 		equ $0		;1==build for VTI 0==build for calc (this avoids the vti $20 bug)

;Several Important Constants
KERNO_VERSION	equ $2		;Identify the installed version of kerno
KERNO_ID	equ 'KN'	;Identifies KerNO
KERNO_SIG	equ '68kN'	;takes the place of the Doors 68kP/68kL
K_VER		equ $40030	;version number (word)
K_ID		equ $40032	;kernel id (word)
K_EXEC		equ $40034	;Pointer to the exec function
K_UNINST	equ $40038	;pointer to the uninstall function
;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
 xdef _nostub
 xdef _ti89
 xdef _ti92plus
 xdef _main
 
_main:
 movem.l a2-a6/d3-d7,-(sp)
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;check to see if installed 
 tst.w K_VER		
 beq InstallKerno
 cmp.w #KERNO_ID,K_ID	;kernel identifier
;address to the uninstall routine... ram resident so later versions can
;uninstall earlier versions without alot of extra code
 bne PreviousKernel	;a kernel other than KerNO is installed
 pea FinishDeinstall(pc)
 move.l K_UNINST,a0
 jmp (a0)
FinishDeinstall:
 bra EmergencyExit
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;install code for kerno...
InstallKerno:
 move.w #$700,d0
 trap #1	;disable interrupts
 move.l d0,d7
 
;detect HW2 calcs without HW2 patch
;i think that Julien Muchembled came up with this, and that
;Kevin Kofler ported it from C to ASM... this is almost an exact
;copy from the beginning of Kevin's h220xtsr
 move.l $c8,d0
 and.l #$600000,d0 ;get the ROM base
 move.l d0,a0
 move.l 260(a0),a1 ;get the pointer to the hardware parameter block
 add.l #$10000,a0
 cmp.l a0,a1 ;check if the hardware parameter block is near enough
 bcc ContinueInstall ;if it is too far, it is HW1
 cmp.w #22,(a1) ;check if the parameter block contains the hardware version
 bls ContinueInstall ;if it is too small, it is HW1
 cmp.l #2,22(a1) ;check the hardware version
 bne ContinueInstall ;if not 2, it is HW1 (or an unknown hardware version)
;end of hardware version detection routine
 move.l $c8,a0
 cmp.l #1000,-4(a0) ;check if more than 1000 entries
 bcs ContinueInstall ;if no, it is AMS 1.xx
 ROM_CALL2 EX_stoBCD
 tst.w 92(a4) ;check for HW2Patch (ROM resident)
 beq ContinueInstall ;if it is installed, refuse installation
 cmp.l #$100,$ac ;check for HW2Patch (RAM resident)
 bne NeedHW2Patch
 
ContinueInstall:
;allocate ram for the kernel
 move.l #(KernoEnd-KernoBegin),-(a7)
 ROM_CALL HeapAllocHigh
 addq.l #4,a7
 
 tst.w d0
 beq LowRam
 
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 addq.l #2,a7
; add.l #$40000,a0	;support for h220xtsr
 move.l a0,a3		;save the pointer for later
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Now, set up the Exception Vector Table
 move.w #KERNO_VERSION,K_VER
 move.w #KERNO_ID,K_ID
 
 lea OffsetTable(pc),a4		;how far from a3
 lea InstallTable(pc),a5	;vector pointers
 lea UninstallTable(pc),a6	;the saved vectors
 
 moveq.w #(EndInstallTable-InstallTable)-1,d0	;how many loops?
 clr.l d1
 clr.l d2
 
InstallLoop:
 move.b (a5)+,d2	;get the address of the old vector
 move.l #$40000,a1
 add.l d2,a1		;add 0x40000 to it to bypass protected memory...
 move.l (a1),(a6)+	;save the old vector
 move.w (a4)+,d1	;get the offset from the beginning
 move.l a3,a0		;restore a0
 add.l d1,a0		;add the offset to the pointer
 move.l a0,(a1)		;install the new interrupt vector
 dbra d0,InstallLoop

 move.l #$40064,a0
 lea OldAutoInt1(pc),a1
 moveq.l #((OldAutoInt5-OldAutoInt1)/4)-1,d0
SaveIntsLoop:
 move.l (a0)+,(a1)+
 dbra d0,SaveIntsLoop
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;copy KerNO to the correct palce in ram
;this is done after setting up the vectors so
;that the saved vector table is saved in the new location
 move.l #(KernoEnd-KernoBegin),-(a7)
 pea.l KernoBegin(pc)
 move.l a3,-(a7)

 ROM_CALL memcpy
 lea.l 12(sp),sp

 move.w d7,d0	;restore interrupts
 trap #1
 
;Display Successful Installation Message
 pea InstallStr(pc)
 bsr DisplayError
 addq.l #4,sp
;;;;;;;;;;;;;;;;;;;;;;;;;;;
EmergencyExit:
 movem.l (sp)+,a2-a6/d3-d7
 rts
;;;;;;;;;;;;;;;;;;;;;;;;;;;
NeedHW2Patch:
 pea NeedPatchStr(pc)
 bra.s DoHelpMsg
;;;;;;;;;;;;;;;;;;;;;;;;;;;
PreviousKernel:
 pea PreviousKernelStr(pc)
 bra.s DoHelpMsg
;;;;;;;;;;;;;;;;;;;;;;;;;;;
LowRam:
 pea LowRamStr(PC)
 ;bra.s DoHelpMsg
;;;;;;;;;;;;;;;;;;;;;;;;;;;
DoHelpMsg:
 bsr DisplayError
 addq.l #4,sp
 bra.s EmergencyExit
;;;;;;;;;;;;;;;;;;;;;;;;;;;
 EVEN
;;;;;;;;;;;;;;;;;;;;;;;;;;;
KernoBegin:
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;possibly allow ppg programs to be run...
;programs that use this will need to be patched!
KernoExec:
 move.l (sp)+,a0
; cmp.l #KERNO_SIG,(a0)	;was it built for kerno?
; bne DoorsPrgm
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;handle KerNO type program here... (a small outline)
; move.w 4(a0),d0	;d0.w = flags (packaged, program, whatever...)
; move.w 6(a0),d0	;d0.w = offset to main program
;ex_patch etc...
; add.l d0,a0		;a0.l = main program
; pea ExecReturnAddr(pc);save a return address so it returns here
; jmp (a0)		;run the program
;ExecReturnAddr:
;ret value support...
; rts
;;;;;;;;;;;;;;;;;;;;;;;;;;;
DoorsPrgm:
 pea KernoDoorsStr(pc)
 bsr DisplayError
 addq.l #4,sp
 rts
;;;;;;;;;;;;;;;;;;;;;;;;;;;
KernoUninstall:

 move.l #0,K_VER
 move.l #0,K_EXEC
 move.l #0,K_UNINST

 lea InstallTable(pc),a1	;vector pointers
 lea UninstallTable(pc),a2	;the saved vectors
 moveq.w #EndInstallTable-InstallTable-1,d0	;how many loops?
 clr.l d1

 UnInstallLoop:
 move.b (a1)+,d1	;get the address of the KerNO vector
 move.l #$40000,a0	;add 0x40000
 add.l d1,a0
 move.l (a2)+,(a0)	;restore the old ti-os vector
 dbra d0,UnInstallLoop

 pea KernoBegin(pc)
 ROM_CALL HeapPtrToHandle
 move.w d0,-(sp)
 ROM_CALL HeapFree
 
 pea KernoDeInStr(pc)
 bsr DisplayError
 lea 10(sp),sp

 rts
;;;;;;;;;;;;;;;;;;;;;;;;;;;
KernoAddressError:
 move #$700,sr
 pea AddressError(pc)
 bra Recover
;;;;;;;;;;;;;;;;;;;;;;;;;;;
KernoIllegalError:
 move #$700,sr
 pea IllegalError(pc)
 bra Recover
;;;;;;;;;;;;;;;;;;;;;;;;;;;
KernoDivError:
 move #$700,sr
 pea DivError(pc)
 bra Recover
;;;;;;;;;;;;;;;;;;;;;;;;;;;
KernoCHKError:
 move #$700,sr
 pea CHKError(pc)
 bra Recover
;;;;;;;;;;;;;;;;;;;;;;;;;;;
KernoTRAPVError:
 move #$700,sr
 pea TRAPVError(pc)
 bra Recover
;;;;;;;;;;;;;;;;;;;;;;;;;;;
KernoPrivError:
 move #$700,sr
 pea PrivError(pc)
 bra Recover
;;;;;;;;;;;;;;;;;;;;;;;;;;;
KernoLine1010Emulator:
 move.l 2(sp),a0	;pointer to the op-code
 move.w (a0),a0		;the actual op-code/error code
 
 cmp.w #$A0A1,a0	;$A1 = ASAP or Exec string too long
 beq skiperror
 
 cmp.w #$A244,a0	;$244 = Invalid program reference
 beq skiperror
 
; cmp.w #$A2B2,a0	;tiams.h	EXPECTED_RPAR_ERROR
; beq skiperror
 
; call the old line 1010 emulator
 move.l OldLineAEmulator(pc),-(sp)
 rts

skiperror:
 add.l #2,2(sp)
 rte
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;
KernoLine1111Emulator:
;Note to self: DO NOT destroy registers that aren't supposto be destroyed...
;this is my own code, but i've also taken _some_ optimization ideas from some one else's code...
;i don't know where that code can be found, or who it was... since ticalc.org is down at the moment...
 move.l 2(sp),a0;get the old pc
 move.w (a0),d0 ;get the instruction that caused the interrupt
 
 cmp.w #$F800,d0;all line 1111 rom calls (F-Line instructions) are =>$F800
 blt KernoBadLine1111Emulator
 
 and.w #$7ff,d0	;mask out the $F800 so we have the index
 lsl.l #2,d0	;multiply by 4  if you use this, make sure that you do not loose any bits that are set or the result will be very wrong
 move usp,a1	;the user stack -- normally == a7
 addq.l #$2,a0	;change the 'pc' to the next instruction in the users code
 move.l a0,-(a1);set the new return address for the rts in the romcall (user stack)
 move a1,usp	;this saves the new user stack pointer (very important)
 
 move.l $C8,a0	;pointer to the jump table
 move.l 0(a0,d0),a0 ;index+table addr = rom_call (i hope this is better than add, move...)
; add.l d0,a0
; move.l (a0),a0
 move.l a0,2(sp);change 'pc' to the rom_call
;there is no need to restore the registers... the calling program will assume the ones that i have used
;will be destroyed by the rom call... and no parameters are passed in registers...
 rte		;exception end... 
;rte calls the rom call, the rom call will return to the program that
;called it thru the return address pushed on the user stack. 

KernoBadLine1111Emulator:
;note to self, if displaying regs for debug info, they must be restored...
 pea LineFError(pc)	;the call was too low, so recover the error
 bra Recover

;;;;;;;;;;;;;;;;;;;;;;;;;;;
KernoESCOnError:
 move #$2700,sr	;disable interrupts
 movem.l a0-a6/d0-d7,-(sp)
 
;is something already being handled?
 lea NoErrorThrow(pc),a1
 tst.w (a1)
 bne SkipCheck
 move.w #1,(a1)
 
 move.l #$600018,a2	;keymask
 move.w (a2),d1		;makes normal power down procedures work better... otherwise, they seem to hang

;is the on key really pressed?
 btst.b #$1,$60001A
 bne DefaultAutoInt6


 bsr CALCULATOR
 tst.b d2
 beq TI89
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TI92+:
;Test the ESC Key
 move.w #%1011111111,$600018	;mask the row of the ESC key
 bsr WaitLoop
 btst.b #6,$60001B		;Test the ESC Key
 beq ESCPressed
 
 ;Test the Diamond Key
 move.w #%1111111110,$600018	;mask the row of the Diamond key
 bsr WaitLoop
 btst.b #1,$60001B		;Test the Diamond Key
 beq DiamondPressed
 bra DefaultAutoInt6		;no need to check TI-89 keys on the TI-92+...

TI89:
;Test the ESC Key
 move.w #%0111111,(a2)	;mask the row of the ESC key
 bsr WaitLoop
 btst.b #0,$60001B	;Test the ESC Key
 beq ESCPressed

;Test the DIAMOND Key
 move.w #%1111110,(a2)	;mask the row of the Diamond key
 bsr WaitLoop
 btst.b #6,$60001B	;Test the DIAMOND Key
 beq DiamondPressed

DefaultAutoInt6:;call the old auto-int 6 handler
 move.w d1,(a2)	;restore the original key mask... otherwise normal power down procedures hang... ie 2nd+Off, Diamond+Off
		 ;do i need to restore the original interrupt mask?
 move.w #$00,(a1)
 movem.l (sp)+,a0-a6/d0-d7
 move.l OldESCOnError(pc),-(sp)
 rts
 
ESCPressed:
 move #$700,sr

LetGoOfESCPlease: ;force the user to let go of ESC... make sure they see the dialog box...
 bsr WaitLoop	;the col mask has already been set... so skip it...
 tst.b d2	;what calc? 	
 beq TI89_LetGoPleaseTest

 btst.b #6,$60001B
 bra TestLetGoOfEscPlease

TI89_LetGoPleaseTest:
 btst.b #0,$60001B

TestLetGoOfEscPlease:
 beq LetGoOfESCPlease
 ROM_CALLF GKeyFlush

 movem.l (sp)+,a0-a6/d0-d7; should change this to lea x(sp),sp...
 pea ESCOnError(pc)
 bra Recover
 
DiamondPressed:
 trap #$4
 move.w #$00,(a1)
 
SkipCheck:
 movem.l (sp)+,a0-a6/d0-d7
 rte

;;;;;;;;;;;;;;;;;;;;;;;;;;;
WaitLoop:
 move.w #$25,d0		;loop 25 times (waste time for row reading)
DoWaitLoop:
 nop
 dbra d0,DoWaitLoop
 rts
;;;;;;;;;;;;;;;;;;;;;;;;;;;
Recover:

;tt: bra tt
;rudimentry support for displaying the contents of registers after a crash
; movem.l a0-a6/d0-d7,-(sp)
; pea KernoRegs(pc)
; pea LCD_MEM
; ROM_CALLF sprintf
; pea LCD_MEM
; 
; bsr DisplayError
; lea 72(sp),sp
 
;make sure that KerNO is in control before recovering...
 lea OffsetTable(pc),a4		;how far from a3
 lea InstallTable(pc),a5	;vector pointers
 
 moveq.w #(EndInstallTable-InstallTable)-1,d0	;how many loops?
 clr.l d1
 clr.l d2
 lea KernoBegin(pc),a3

AssertLoop:
 move.b (a5)+,d2	;get the address of the old vector
 move.l #$40000,a1
 add.l d2,a1		;bypass protected memory...
 move.w (a4)+,d1	;get the offset from the beginning
 move.l a3,a0		;restore a0
 add.l d1,a0		;add the offset to the pointer
 move.l a0,(a1)		;restore the kerno interrupt vector
 dbra d0,AssertLoop
 
 move.l #$40064,a0		;restore the auto-ints
 lea OldAutoInt1(pc),a1
 moveq.l #((OldAutoInt5-OldAutoInt1)/4)-1,d0
RestoreIntsLoop:
 add.l #$40000,(a0)
 move.l (a1)+,(a0)+
 dbra d0,RestoreIntsLoop
 
 ROM_CALLF PortRestore		;make sure the os has the default lcd_mem...

;restore the bottom most line on the screen (just in case it was messed up...)
;the user can do the rest...  i can't do it from here...
 move.l #30,-(sp)
 move.w #$ff,-(sp)
 bsr CALCULATOR
 tst.b d2
 bne Restore92pScreen
 pea.l $56e6
 bra RestoreTheScreen
Restore92pScreen:
 pea.l $5a2e
RestoreTheScreen:
 ROM_CALLF memset
 lea 10(sp),sp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

 move #0,ccr			;enable interrupts
 bsr DisplayError		;inform the user
 lea NoErrorThrow(pc),a0	;get addr of auto-int 6 flag
 move.w #0,(a0)			;reset the auto-int 6 flag
 ERR_THROW $6			;this is what doorsos uses...
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;
DisplayError:
 move.l #$00010000,-(sp)	;bt_ok, bt_none
 move.l 8(sp),-(sp)		;get the passed argument...
 pea RecoveredStr(pc)
 ROM_CALL DlgMessage
 lea 12(sp),sp
 rts
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;d2=0 if ti-89
CALCULATOR:
 move.l $C8,d2
 swap d2
 lsr.w #6,d2
 rts
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;
UninstallTable:
OldExecFunc	  dc.l 0
OldUninstFunc	  dc.l 0
OldAddressError:  dc.l 0
OldIllegalError:  dc.l 0
OldDivError:	  dc.l 0
OldCHKError:	  dc.l 0
OldTRAPVError:	  dc.l 0
	ifeq VTI
OldPrivError:	  dc.l 0
	endc
OldLineAEmulator: dc.l 0
OldLineFEmulator: dc.l 0
OldESCOnError:	  dc.l 0
OldAutoInt1:	  dc.l 0
OldAutoInt2:	  dc.l 0
OldAutoInt3:	  dc.l 0
OldAutoInt4:	  dc.l 0
OldAutoInt5:	  dc.l 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;
OffsetTable:
 dc.w KernoExec-KernoBegin	;should == 0
 dc.w KernoUninstall-KernoBegin
 dc.w KernoAddressError-KernoBegin
 dc.w KernoIllegalError-KernoBegin
 dc.w KernoDivError-KernoBegin
 dc.w KernoCHKError-KernoBegin
 dc.w KernoTRAPVError-KernoBegin
	ifeq VTI
 dc.w KernoPrivError-KernoBegin
	endc
 dc.w KernoLine1010Emulator-KernoBegin
 dc.w KernoLine1111Emulator-KernoBegin
 dc.w KernoESCOnError-KernoBegin
;;;;;;;;;;;;;;;;;;;;;;;;;;; 
NoErrorThrow:	dc.w 0			;avoids problems with multiple interrupts...
;;;;;;;;;;;;;;;;;;;;;;;;;;;
InstallTable:
 dc.b $34	;Exec function
 dc.b $38	;uninstall routine
 dc.b $C	;address
 dc.b $10	;illegal
 dc.b $14	;divide/0
 dc.b $18	;CHK
 dc.b $1C	;TrapV
	ifeq VTI
 dc.b $20	;Priv
	endc
 dc.b $28	;Line 1010
 dc.b $2C	;line 1111
 dc.b $78	;auto-int 6 (ON key)
EndInstallTable:;used to get the number of entries for loops
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Internal Strings...
;KernoRegs:	dc.b 'd0=%lx d1=%lx'
;		dc.b ' '
;		dc.b 'd2=%lx d3=%lx'
;		dc.b ' '
;		dc.b 'd4=%lx d5=%lx'
;		dc.b ' '
;		dc.b 'd6=%lx d7=%lx'
;		dc.b ' '
;		dc.b 'a0=%lx a1=%lx'
;		dc.b ' '
;		dc.b 'a2=%lx a3=%lx'
;		dc.b ' '
;		dc.b 'a4=%lx a5=%lx a6=%lx'
;		dc.b ' '
;		dc.b 's0=%lx s1=%lx s2=%lx',0
AddressError:	dc.b 'Address Error',0
IllegalError:	dc.b 'Illegal Instruction',0
DivError:	dc.b 'Divide By Zero',0
CHKError:	dc.b 'CHK Instruction',0
TRAPVError:	dc.b 'TRAPV Instruction',0
PrivError:	dc.b 'Privilege Violation',0
LineFError:	dc.b 'Line 1111 Emulator',0
ESCOnError:	dc.b 'ESC+ON Pressed',0
;;;;;;;;;;;;;;;;;;;;;;;;;;;
RecoveredStr:	dc.b 'KerNO v1.2',0
KernoDeInStr:	dc.b 'KerNO Uninstalled',0
KernoDoorsStr:	dc.b 'KerNO does not support DoorsOS',0
;;;;;;;;;;;;;;;;;;;;;;;;;;;
KernoEnd:
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Data for the install portion of this program
	ifne VTI
InstallStr:		dc.b 'KerNO v1.2 (VTI) Installed',0
	endc
	ifeq VTI
InstallStr:		dc.b 'KerNO v1.2 Installed',0
	endc
LowRamStr: 		dc.b 'ERR 1: Low Memory',0
PreviousKernelStr:	dc.b 'ERR 2: Previous Kernel',0
NeedPatchStr:		dc.b 'ERR 3: HW2 patch needed',0
;;;;;;;;;;;;;;;;;;;;;;;;;;;
 END
